<?php

require_once 
    dirname(dirname(__FILE__)) . DIRECTORY_SEPARATOR . 'tima.php';

if (!defined('DS')) {
    define('DS', DIRECTORY_SEPARATOR);
}
if (!defined('SIMPLE_TEST')) {
    define('SIMPLE_TEST', dirname(__FILE__) . DS . 'simpletest');
}

require_once 
    SIMPLE_TEST . DS . 'unit_tester.php';
require_once
    SIMPLE_TEST . DS . 'reporter.php';

/**
 *  Config饹Υƥȥ
 */
class Test_Config extends UnitTestCase 
{

    /**
     * ե֥ѥ1
     * 
     * @var    string
     * @access private
     */
    var $_dirPath1;

    /**
     * ե֥ѥ2
     * 
     * @var    string
     * @access private
     */
    var $_dirPath2;

    /**
     * 󥹥ȥ饯
     * 
     * @access puclic
     */
    function Test_Request()
    {
        $this->UnitTestCase();

        $this->_dirPath1 = dirname(__FILE__) . DS . 'etc1' . DS;
        $this->_dirPath2 = dirname(__FILE__) . DS . 'etc2' . DS;

        require_once 
            dirname(dirname(__FILE__)) . DS . 'tima' . DS . 'Config.class.php';
    }

    /**
     * ߡե
     * 
     * @return void
     * @access puclic
     */
    function setup()
    {
        $test1_ini = '
<?php
return array(
    array("key" => "a", "value" => 1),
    array("key" => "b", "value" => 2),
    array("key" => "c", "value" => 3),
  );
';
        $test2_ini = '
<?php
return array(
    array("key" => "a",    "value" => 999),
    array("key" => "foo",  "value" => "bar"),
    array("key" => "list", "value" => array(1,2,3)),
  );
';
        $test3_ini = '
<?php
return array(
    array("key" => "a", "value" => 10),
    array("key" => "b", "value" => 20),
    array("key" => "c", "value" => 30),
    array("key" => "foo",  "value" => "zoo"),
    array("key" => "list", "value" => array(100,101,102)),
    array("key" => "bar",  "value" => "foo"),
  );
';

        @mkdir($this->_dirPath1);
        @mkdir($this->_dirPath2);

        $handle = fopen($this->_dirPath1 . 'test1-ini.php', 'w');
        fwrite($handle, $test1_ini);

        $handle = fopen($this->_dirPath1 . 'test2-ini.php', 'w');
        fwrite($handle, $test2_ini);

        $handle = fopen($this->_dirPath2 . 'test3-ini.php', 'w');
        fwrite($handle, $test3_ini);
    }

    /**
     * ߡե
     * 
     * @return void
     * @access puclic
     */
    function tearDown()
    {
        if ($dh = @opendir($this->_dirPath1)) {
            while (($file = @readdir($dh)) !== false) {
                if ($file == '.' || $file == '..') {
                    continue;
                }
                @unlink($this->_dirPath1 . $file);
            }
            closedir($dh);
        }
        @rmdir($this->_dirPath1);

        if ($dh = @opendir($this->_dirPath2)) {
            while (($file = @readdir($dh)) !== false) {
                if ($file == '.' || $file == '..') {
                    continue;
                }
                @unlink($this->_dirPath2 . $file);
            }
            closedir($dh);
        }
        @rmdir($this->_dirPath2);
    }

    /**
     * Config::readConfig() ᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testReadConfig()
    {
        $config = &new Config;

        $config->setEtcDir(dirname(__FILE__) . DS . 'foobar' . DS);

        // ե֥ѥʤΤǵ
        $this->assertFalse($config->readConfig('test1'));

        $config->setEtcDir($this->_dirPath1);

        // եɤ߹ߤ鿿
        $this->assertTrue($config->readConfig('test1'));
        $this->assertTrue($config->readConfig('test2'));

        // ʸѴƸΤǰʲ⿿
        $this->assertTrue($config->readConfig('Test1'));
        $this->assertTrue($config->readConfig('TEST2'));

        // ¸ߤʤեϤ
        $this->assertFalse($config->readConfig('foobar'));

        // ե֥ѥ̤ʤΤǵ
        $this->assertFalse($config->readConfig('test3'));

        $config->setEtcDir($this->_dirPath2);

        // ե֥ѥɲäΤǿ
        $this->assertTrue($config->readConfig('test1'));
        $this->assertTrue($config->readConfig('test2'));
        $this->assertTrue($config->readConfig('test3'));
    }

    /**
     * Config::readConfig() ᥽åɤΥƥȤ2
     * 
     * @return void
     * @access puclic
     */
    function testReadConfig2()
    {
        $config = &new Config;
        $config->setEtcDir($this->_dirPath1);
        $config->setEtcDir($this->_dirPath2);

        $this->assertNull($config->get('a'));
        $this->assertNull($config->get('b'));
        $this->assertNull($config->get('c'));
        $this->assertNull($config->get('foo'));
        $this->assertNull($config->get('list'));
        $this->assertNull($config->get('bar'));

        $config->readConfig('test1');
        $this->assertEqual(1, $config->get('a'));
        $this->assertEqual(2, $config->get('b'));
        $this->assertEqual(3, $config->get('c'));
        $this->assertNull($config->get('foo'));
        $this->assertNull($config->get('list'));
        $this->assertNull($config->get('bar'));

        $config->readConfig('test2');
        $this->assertEqual(999, $config->get('a'));
        $this->assertEqual(2, $config->get('b'));
        $this->assertEqual(3, $config->get('c'));
        $this->assertEqual('bar', $config->get('foo'));
        $this->assertEqual(array(1, 2, 3), $config->get('list'));
        $this->assertNull($config->get('bar'));

        $config->readConfig('test3');
        $this->assertEqual(10, $config->get('a'));
        $this->assertEqual(20, $config->get('b'));
        $this->assertEqual(30, $config->get('c'));
        $this->assertEqual('zoo', $config->get('foo'));
        $this->assertEqual(array(100, 101, 102), $config->get('list'));
        $this->assertEqual('foo', $config->get('bar'));
    }

    /**
     * Config::set() / Config::get() ᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testSet()
    {
        $config = &new Config;

        $config->set('a', 100);
        $config->set('b', 200);
        $config->set('c', 300);

        $config->set('b', 1, 'foo');
        $config->set('b', 1, 'bar');
        $config->set('c', 1, 'foo');
        $config->set('c', 1, 'bar');

        $this->assertEqual(100, $config->get('a'));
        $this->assertEqual(200, $config->get('b'));
        $this->assertEqual(300, $config->get('c'));
        $this->assertEqual(1, $config->get('b', 'foo'));
        $this->assertEqual(1, $config->get('b', 'bar'));
        $this->assertEqual(1, $config->get('c', 'foo'));
        $this->assertEqual(1, $config->get('c', 'bar'));


        $config->set('a', 'a');
        $config->set('b', 'b');
        $config->set('c', 'c');

        $config->set('b', -1, 'foo');
        $config->set('c',  0, 'bar');

        $this->assertEqual('a', $config->get('a'));
        $this->assertEqual('b', $config->get('b'));
        $this->assertEqual('c', $config->get('c'));
        $this->assertEqual(-1, $config->get('b', 'foo'));
        $this->assertEqual( 1, $config->get('b', 'bar'));
        $this->assertEqual( 1, $config->get('c', 'foo'));
        $this->assertEqual( 0, $config->get('c', 'bar'));
    }

    /**
     * Config::getByNamespace() ᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testGetByNamespace()
    {
        $config = &new Config;

        $config->set('a', 100, 'int');
        $config->set('b', 200, 'int');
        $config->set('c', 300, 'int');

        $config->set('a', 0.1, 'float');
        $config->set('b', 0.2, 'float');
        $config->set('c', 0.3, 'float');

        $config->set('a', 'foo', 'string');
        $config->set('b', 'bar', 'string');
        $config->set('c', 'zoo', 'string');

        $this->assertEqual(
            array('a' => 100, 'b' => 200, 'c' => 300), 
            $config->getByNamespace('int'));
        $this->assertEqual(
            array('a' => 0.1, 'b' => 0.2, 'c' => 0.3), 
            $config->getByNamespace('float'));
        $this->assertEqual(
            array('a' => 'foo', 'b' => 'bar', 'c' => 'zoo'), 
            $config->getByNamespace('string'));    }
}

$test = &new Test_Config;
$test->run(new TextReporter);
