<?php

require_once 
    dirname(dirname(dirname(dirname(__FILE__)))) . DIRECTORY_SEPARATOR . 'tima.php';

if (!defined('SIMPLE_TEST')) {
    define('SIMPLE_TEST', dirname(dirname(dirname(__FILE__))) . DS . 'simpletest');
}
require_once 
    SIMPLE_TEST . DS . 'unit_tester.php';
require_once
    SIMPLE_TEST . DS . 'reporter.php';

/**
 *  Connector_Csv⥸塼롦饹Υƥȥ
 */
class Test_Module_Connector_Csv extends UnitTestCase 
{

    /**
     * ⥸塼Υƥ
     * 
     * @return void
     * @access puclic
     */
    function testZip()
    {
        $module = &Module::factory('Connector');

        $this->assertEqual('"a","b","c"', $module->zip('Csv', array('a','b','c')));
        $this->assertEqual('"a","","c"', $module->zip('Csv', array('a','','c')));
        $this->assertEqual('"a"," ","c"', $module->zip('Csv', array('a',' ','c')));
        $this->assertEqual('"a","  c  "', $module->zip('Csv', array('a','  c  ')));

        $this->assertEqual(
            "\"a\nb\nc\",\"\\\"1\\\"\\\"2\\\"\\\"3\\\"\",\"A\nB\nC\"", 
            $module->zip('Csv', array("a\nb\nc",'"1""2""3"',"A\nB\nC")));

        $this->assertEqual(
            '"1","2","3"', 
            $module->zip(
                'Csv', 
                array('a' => 1, 'b' => 2, 'c' => 3)));

        $this->assertEqual('"a","1"', $module->zip('Csv', array('a',array(1))));
        $this->assertEqual(
            '"a","b","c","1,2,3,A,B,C"', 
            $module->zip(
                'Csv', 
                array('a','b','c',array(1,2,3,array('A','B','C')))));

        $animal = array(
                'dog', 
                'cat', 
                'panda', 
                'koala', 
                'fox', 
                'bird', 
            );
        $this->assertEqual($this->toCsvLine($animal), $module->zip('Csv', $animal));

        $fruit = array(
                "apple or \"Japanese pear\".\nnot pear", 
                'banana', 
                'mango', 
                'grape', 
                'lemon', 
                'strawberry', 
            );
        $this->assertEqual($this->toCsvLine($fruit), $module->zip('Csv', $fruit));
    }


    /**
     * CSVѴ
     * 
     * @param  array  $attribute
     * @return string
     * @access private
     */
    function toCsvLine($attribute)
    {
        $row = array();
        foreach ($attribute as $col) {
            $row[] = 
                sprintf(
                    '"%s"', 
                    mb_ereg_replace('"', '\\"', $col));
        }

        return
            implode(',', $row);
    }
}

$test = &new Test_Module_Connector_Csv;
$test->run(new TextReporter);
