<?php

require_once 
    dirname(dirname(dirname(dirname(__FILE__)))) . DIRECTORY_SEPARATOR . 'tima.php';

if (!defined('SIMPLE_TEST')) {
    define('SIMPLE_TEST', dirname(dirname(dirname(__FILE__))) . DS . 'simpletest');
}
require_once 
    SIMPLE_TEST . DS . 'unit_tester.php';
require_once
    SIMPLE_TEST . DS . 'reporter.php';

/**
 *  Connector_Date⥸塼롦饹Υƥȥ
 */
class Test_Module_Connector_Date extends UnitTestCase 
{

    /**
     * ⥸塼Υƥ
     * 
     * @return void
     * @access puclic
     */
    function testZip()
    {
        $module = &Module::factory('Connector');

        $this->assertEqual(
            '1980ǯ1210', 
            $module->zip(
                'Date', 
                array('year' => '1980', 'month' => '12', 'day' => '10')));
        $this->assertEqual(
            '1980ǯ1210', 
            $module->zip(
                'Date', 
                array('day' => '10', 'month' => '12', 'year' => '1980')));
        $this->assertEqual(
            '1980ǯ1210', 
            $module->zip(
                'Date', 
                array('year' => '1980', 'month' => '12', 'day' => '10', 1, 2, 3)));
        $this->assertEqual(
            '1980ǯ1210', 
            $module->zip(
                'Date', 
                array(1, 'year' => '1980', 2, 'month' => '12', 3, 'day' => '10',)));

        $this->assertEqual(
            '', 
            $module->zip(
                'Date', 
                array('year' => '', 'month' => '12', 'day' => '10')));
        $this->assertEqual(
            '', 
            $module->zip(
                'Date', 
                array('year' => '1980', 'month' => '', 'day' => '10')));
        $this->assertEqual(
            '', 
            $module->zip(
                'Date', 
                array('year' => '1980', 'month' => '12')));
        $this->assertEqual(
            '', 
            $module->zip(
                'Date', 
                array('year' => '1980', 'month' => '12', 10)));
        $this->assertEqual('', $module->zip('Date', array('1980', '12', '10')));

        $this->assertEqual(
            '1980-12-10', 
            $module->zip(
                'Date', 
                array('year' => '1980', 'month' => '12', 'day' => '10'), 
                '%1$s-%2$s-%3$s'));
        $this->assertEqual(
            '1980ǯ[12]', 
            $module->zip(
                'Date', 
                array('year' => '1980', 'month' => '12', 'day' => '10'), 
                '%1$sǯ[%2$s]'));
    }
}

$test = &new Test_Module_Connector_Date;
$test->run(new TextReporter);
