<?php

require_once 
    dirname(dirname(dirname(dirname(__FILE__)))) . DIRECTORY_SEPARATOR . 'tima.php';

if (!defined('SIMPLE_TEST')) {
    define('SIMPLE_TEST', dirname(dirname(dirname(__FILE__))) . DS . 'simpletest');
}
require_once 
    SIMPLE_TEST . DS . 'unit_tester.php';
require_once
    SIMPLE_TEST . DS . 'reporter.php';

/**
 *  Connector_Postcode⥸塼롦饹Υƥȥ
 */
class Test_Module_Connector_Postcode extends UnitTestCase 
{

    /**
     * ⥸塼Υƥ
     * 
     * @return void
     * @access puclic
     */
    function testZip()
    {
        $module = &Module::factory('Connector');

        $this->assertEqual(
            '123-4567', 
            $module->zip('Postcode', array('first' => '123', 'last' => '4567')));
        $this->assertEqual(
            '123-4567', 
            $module->zip('Postcode', array('last' => '4567', 'first' => '123')));
        $this->assertEqual(
            '123-4567', 
            $module->zip(
                'Postcode', 
                array('first' => '123', 'last' => '4567', 'a', 'b', 'c')));
        $this->assertEqual(
            '123-4567', 
            $module->zip(
                'Postcode', 
                array(1, 2, 3, 'first' => '123', 'a', 'b', 'c', 'last' => '4567')));

        $this->assertEqual('', $module->zip('Postcode', array('first' => '123')));
        $this->assertEqual('', $module->zip('Postcode', array('last'  => '4567')));
        $this->assertEqual('', $module->zip('Postcode', array('123', '4567')));
        $this->assertEqual(
            '', 
            $module->zip('Postcode', array('first' => '', 'last' => '4567')));
        $this->assertEqual(
            '', 
            $module->zip('Postcode', array('first' => '123', 'last' => '')));
        $this->assertEqual(
            '', 
            $module->zip('Postcode', array('foo' => '123', 'bar' => '4567')));
    }
}

$test = &new Test_Module_Connector_Postcode;
$test->run(new TextReporter);
