<?php

require_once 
    dirname(dirname(dirname(dirname(__FILE__)))) . DIRECTORY_SEPARATOR . 'tima.php';

if (!defined('SIMPLE_TEST')) {
    define('SIMPLE_TEST', dirname(dirname(dirname(__FILE__))) . DS . 'simpletest');
}
require_once 
    SIMPLE_TEST . DS . 'unit_tester.php';
require_once
    SIMPLE_TEST . DS . 'reporter.php';

/**
 *  Connector_Separate⥸塼롦饹Υƥȥ
 */
class Test_Module_Connector_Separate extends UnitTestCase 
{

    /**
     * ⥸塼Υƥ
     * 
     * @return void
     * @access puclic
     */
    function testZip()
    {
        $module = &Module::factory('Connector');

        $this->assertEqual('a,b,c', $module->zip('Separate', array('a','b','c')));
        $this->assertEqual('a,c', $module->zip('Separate', array('a','','','c')));
        $this->assertEqual('a,c', $module->zip('Separate', array('a','    ','c')));
        $this->assertEqual('a,  c  ', $module->zip('Separate', array('a','  c  ')));
        $this->assertEqual("a\nb\nc", $module->zip('Separate', array("a\nb\nc")));

        $this->assertEqual(
            '1,2,3', 
            $module->zip(
                'Separate', 
                array('a' => 1, 'b' => 2, 'c' => 3)));

        $this->assertEqual('a,1', $module->zip('Separate', array('a',array(1))));
        $this->assertEqual(
            'a,b,c,1,2,3,A,B,C', 
            $module->zip(
                'Separate', 
                array('a','b','c',array(1,2,3,array('A','B','C')))));

        $this->assertEqual(
            'a;b;c', 
            $module->zip('Separate', array('a', 'b', 'c'), ';'));
        $this->assertEqual(
            '1-2-3-4-5-6-7-8-9-10', 
            $module->zip('Separate', range(1,10), '-'));
    }
}

$test = &new Test_Module_Connector_Separate;
$test->run(new TextReporter);
