<?php

require_once 
    dirname(dirname(dirname(dirname(__FILE__)))) . DIRECTORY_SEPARATOR . 'tima.php';

if (!defined('SIMPLE_TEST')) {
    define('SIMPLE_TEST', dirname(dirname(dirname(__FILE__))) . DS . 'simpletest');
}
require_once 
    SIMPLE_TEST . DS . 'unit_tester.php';
require_once
    SIMPLE_TEST . DS . 'reporter.php';

/**
 *  Connector_Telephone⥸塼롦饹Υƥȥ
 */
class Test_Module_Connector_Telephone extends UnitTestCase 
{

    /**
     * ⥸塼Υƥ
     * 
     * @return void
     * @access puclic
     */
    function testZip()
    {
        $module = &Module::factory('Connector');

        $this->assertEqual(
            '03-1234-5678', 
            $module->zip(
                'Telephone', 
                array('area' => '03', 'city' => '1234', 'local' => '5678')));
        $this->assertEqual(
            '03-1234-5678', 
            $module->zip(
                'Telephone', 
                array('city' => '1234', 'local' => '5678', 'area' => '03')));
        $this->assertEqual(
            '03-1234-5678', 
            $module->zip(
                'Telephone', 
                array('area' => '03', 'city' => '1234', 'local' => '5678', 1, 2)));
        $this->assertEqual(
            '03-1234-5678', 
            $module->zip(
                'Telephone', 
                array(1, 2, 'area' => '03', 'city' => '1234', 'local' => '5678')));

        $this->assertEqual(
            '', 
            $module->zip(
                'Telephone', 
                array('area' => '03', 'city' => '1234')));
        $this->assertEqual(
            '', 
            $module->zip(
                'Telephone', 
                array('local' => '5678')));
        $this->assertEqual(
            '', 
            $module->zip(
                'Telephone', 
                array('area' => '03', 'city' => '', 'local' => '5678')));
        $this->assertEqual(
            '', 
            $module->zip('Telephone', array('03', '1234', '5678')));
        $this->assertEqual(
            '', 
            $module->zip(
                'Telephone', 
                array('area' => '03', 'city' => '1234', 'foo' => '5678')));
    }
}

$test = &new Test_Module_Connector_Telephone;
$test->run(new TextReporter);
