<?php

require_once 
    dirname(dirname(dirname(dirname(__FILE__)))) . DIRECTORY_SEPARATOR . 'tima.php';

if (!defined('SIMPLE_TEST')) {
    define('SIMPLE_TEST', dirname(dirname(dirname(__FILE__))) . DS . 'simpletest');
}
require_once 
    SIMPLE_TEST . DS . 'unit_tester.php';
require_once
    SIMPLE_TEST . DS . 'reporter.php';

/**
 *  Connector_Time⥸塼롦饹Υƥȥ
 */
class Test_Module_Connector_Time extends UnitTestCase 
{

    /**
     * ⥸塼Υƥ
     * 
     * @return void
     * @access puclic
     */
    function testZip()
    {
        $module = &Module::factory('Connector');

        $this->assertEqual(
            '2112ʬ10', 
            $module->zip(
                'Time', 
                array('hour' => '21', 'min' => '12', 'sec' => '10')));
        $this->assertEqual(
            '2112ʬ10', 
            $module->zip(
                'Time', 
                array('sec' => '10', 'min' => '12', 'hour' => '21')));
        $this->assertEqual(
            '2112ʬ10', 
            $module->zip(
                'Time', 
                array('hour' => '21', 'min' => '12', 'sec' => '10', 1, 2, 3)));
        $this->assertEqual(
            '2112ʬ10', 
            $module->zip(
                'Time', 
                array(1, 'hour' => '21', 2, 'min' => '12', 3, 'sec' => '10',)));

        $this->assertEqual(
            '', 
            $module->zip(
                'Time', 
                array('hour' => '', 'min' => '12', 'sec' => '10')));
        $this->assertEqual(
            '', 
            $module->zip(
                'Time', 
                array('hour' => '21', 'min' => '', 'sec' => '10')));
        $this->assertEqual(
            '', 
            $module->zip(
                'Time', 
                array('hour' => '21', 'min' => '12')));
        $this->assertEqual(
            '', 
            $module->zip(
                'Time', 
                array('hour' => '21', 'min' => '12', 10)));
        $this->assertEqual('', $module->zip('Time', array('21', '12', '10')));

        $this->assertEqual(
            '21:12:10', 
            $module->zip(
                'Time', 
                array('hour' => '21', 'min' => '12', 'sec' => '10'), 
                '%1$s:%2$s:%3$s'));
        $this->assertEqual(
            '21...12', 
            $module->zip(
                'Time', 
                array('hour' => '21', 'min' => '12', 'sec' => '10'), 
                '%1$s...%2$s'));
    }
}

$test = &new Test_Module_Connector_Time;
$test->run(new TextReporter);
