<?php

require_once 
    dirname(dirname(__FILE__)) . DIRECTORY_SEPARATOR . 'tima.php';

if (!defined('DS')) {
    define('DS', DIRECTORY_SEPARATOR);
}
if (!defined('SIMPLE_TEST')) {
    define('SIMPLE_TEST', dirname(__FILE__) . DS . 'simpletest');
}

require_once 
    SIMPLE_TEST . DS . 'unit_tester.php';
require_once
    SIMPLE_TEST . DS . 'reporter.php';

/**
 *  Request饹Υƥȥ
 */
class Test_Request extends UnitTestCase 
{

    /**
     * 󥹥ȥ饯
     * 
     * @access puclic
     */
    function Test_Request()
    {
        $this->UnitTestCase();

        require_once 
            dirname(dirname(__FILE__)) . DS . 'tima' . DS . 'Request.class.php';
    }

    /**
     * ꥯѿ
     * 
     * @return void
     * @access puclic
     */
    function setup()
    {
        $_SERVER = array();
        $_GET    = array();
        $_POST   = array();
        $_COOKIE = array();
    }

    /**
     * 󥹥ȥ饯Υƥ
     * - 󥹥ȥ饯ΰǼꥯȤΥ᥽åɤǤ
     *  - Ƥ᥽åɤϡGETסPOST
     *   - GETΤߤ  => array('g')
     *   - POSTΤߤ => array('p')
     * - ꥯȤʣǤ
     *  - Ʊ̾ѿ¸ߤϡνǾ񤭤ޤ
     *  - array('g', 'p') => Ʊ̾ѿPOSTͤǾ
     *  - array('p', 'g') => Ʊ̾ѿGETͤǾ
     * - ά줿ˤϥꥯȤ˻Ѥ줿᥽åɤưȽ
     *  - GETΥꥯ  => GETΥꥯȤΤߤ
     *  - POSTΥꥯ => POSTΥꥯȤΤߤ
     * 
     * @return void
     * @access puclic
     */
    function testConstructor()
    {
        $_GET  = array('first' => 'a', 'second' => 'b', 'get'  => '1');
        $_POST = array('first' => 'A', 'second' => 'B', 'post' => '1');

        $post_request = &new Request(array('p'));
        $this->assertTrue($post_request->exists('post'));
        $this->assertFalse($post_request->exists('get'));

        $get_request = &new Request(array('g'));
        $this->assertTrue($get_request->exists('get'));
        $this->assertFalse($get_request->exists('post'));

        $pg_request = &new Request(array('p', 'g'));
        $this->assertEqual('a', $pg_request->get('first'));
        $this->assertEqual('b', $pg_request->get('second'));

        $gp_request = &new Request(array('g', 'p'));
        $this->assertEqual('A', $gp_request->get('first'));
        $this->assertEqual('B', $gp_request->get('second'));

        $_SERVER['REQUEST_METHOD'] = 'GET';
        $get_request = new Request;
        $this->assertTrue($get_request->exists('get'));
        $this->assertFalse($get_request->exists('post'));

        $_SERVER['REQUEST_METHOD'] = 'POST';
        $post_request = &new Request;
        $this->assertTrue($post_request->exists('post'));
        $this->assertFalse($post_request->exists('get'));
    }

    /**
     * Request::set()Request::get()᥽åɤΥƥ
     * - Request::get()᥽åɤϥꥯȤ¸ߤʤСnullפֵѤ
     * - Request::set()᥽åɤϥꥯȤ¸ߤʤͤǤʤ
     * - ʸ¿򰷤
     * - Request::set()᥽åɤǤξ񤭤ϥ󥹥ѿˤΤߺ
     *  - ̤Υ󥹥Ǥϥꥯѿ˱ƶʤ
     * 
     * @return void
     * @access puclic
     */
    function testSet2Get()
    {
        $_GET = array('var' => 'foo');
        $_SERVER['REQUEST_METHOD'] = 'GET';
        $request = new Request;

        $this->assertEqual('foo', $request->get('var'));
        $this->assertNull($request->get('non_var'));

        @$request->set('non_var', 'value');
        $this->assertNull($request->get('non_var'));

        $request->set('var', 'hoge');
        $this->assertIdentical('hoge', $request->get('var'));
        $request->set('var', array('key' => 'value'));
        $this->assertIdentical(array('key' => 'value'), $request->get('var'));
        $request->set('var', 128);
        $this->assertIdentical(128, $request->get('var'));
        $request->set('var', 3.14159265);
        $this->assertIdentical(3.14159265, $request->get('var'));
        $request->set('var', true);
        $this->assertIdentical(true, $request->get('var'));

        $request_b = new Request;
        $this->assertEqual('foo', $request->get('var'));
    }

    /**
     * Request::getAll()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testGetAll()
    {
        $_GET = array('today' => 0, 'tomorrow' => 1, 'yesterday' => -1);
        $_SERVER['REQUEST_METHOD'] = 'GET';
        $request = new Request;

        $this->assertEqual(
            array('today' => 0, 'tomorrow' => 1, 'yesterday' => -1), 
            $request->getAll());
    }

    /**
     * Request::getNames()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testNames()
    {
        $_GET = array('today' => 0, 'tomorrow' => 1, 'yesterday' => -1);
        $_SERVER['REQUEST_METHOD'] = 'GET';
        $request = new Request;

        $this->assertEqual(
            array('today', 'tomorrow', 'yesterday'), 
            $request->getNames());
    }

    /**
     * Request::getAll()Request::getNames()᥽åɤΥƥ
     * - ꥯȤѿ¸ߤп¸ߤʤе
     * - ʸ""פϿ
     * - Ρ0פϿ
     * - ͡falseפϿ
     * - array()פϿ
     * - nullϵ
     * 
     * @return void
     * @access puclic
     */
    function testExists()
    {
        $_GET = array(
                'foo'     => 'bar', 
                'string'  =>  '', 
                'integer' =>  0, 
                'boolean' => false, 
                'array'   => array(), 
                'null'    => null, 
            );
        $_SERVER['REQUEST_METHOD'] = 'GET';
        $request = new Request;

        $this->assertTrue($request->exists('foo'));
        $this->assertFalse($request->exists('hoge'));

        $this->assertTrue($request->exists('string'));
        $this->assertTrue($request->exists('integer'));
        $this->assertTrue($request->exists('boolean'));
        $this->assertTrue($request->exists('array'));
        $this->assertFalse($request->exists('null'));
    }

    /**
     * Request::getAcceptRequest()᥽åɤΥƥ
     * - Ǽ᥽åɤǤ
     *  - Ƥ᥽åɤϡGETסPOSTסCookieסQuery-String
     *   - GETΤߤ          => array('g')
     *   - POSTΤߤ         => array('p')
     *   - CookieΤߤ       => array('c')
     *   - Query-StringΤߤ => array('q')
     * - ά줿ˤϡarray('g', 'p')פǥե
     * - ¸ߤʤꥯѿäˤϡnullפ֤
     * - ꥯȤʣǤ
     *  - Ʊ̾ѿ¸ߤϡνǾ񤭤ޤ
     *  - array('g', 'p', 'c', 'q') => Ʊ̾ѿQuery-StringͤǾ
     *  - array('c', 'p', 'g')      => Ʊ̾ѿGETͤǾ
     * 
     * @return void
     * @access puclic
     */
    function testGetAcceptRequest()
    {
        $_GET = array(
                'apple'  => 'like', 
                'grape'  => 'love', 
                'mango'  => 'dislike', 
                'method' => 'get', 
            );
        $_POST = array(
                'koala'  => 'like', 
                'bare'   => 'love', 
                'dog'    => 'dislike', 
                'method' => 'post', 
            );
        $_COOKIE = array(
                'car'    => 'like', 
                'train'  => 'love', 
                'jet'    => 'dislike', 
                'method' => 'cookie', 
            );
        $_SERVER['QUERY_STRING'] = 
            'first=1&second=two&third[]=3&third[]=three&method=query_string';

        $request = new Request;

        $this->assertEqual('love', $request->getAcceptRequest('grape',  array('g')));
        $this->assertNull($request->getAcceptRequest('bare',   array('g')));
        $this->assertNull($request->getAcceptRequest('train',  array('g')));
        $this->assertNull($request->getAcceptRequest('second', array('g')));
        $this->assertEqual('love', $request->getAcceptRequest('bare',   array('p')));
        $this->assertNull($request->getAcceptRequest('grape',  array('p')));
        $this->assertNull($request->getAcceptRequest('train',  array('p')));
        $this->assertNull($request->getAcceptRequest('second', array('p')));
        $this->assertEqual('love', $request->getAcceptRequest('train',  array('c')));
        $this->assertNull($request->getAcceptRequest('bare',   array('c')));
        $this->assertNull($request->getAcceptRequest('grape',  array('c')));
        $this->assertNull($request->getAcceptRequest('second', array('c')));
        $this->assertEqual('two',  $request->getAcceptRequest('second', array('q')));
        $this->assertNull($request->getAcceptRequest('bare',   array('q')));
        $this->assertNull($request->getAcceptRequest('grape',  array('q')));
        $this->assertNull($request->getAcceptRequest('train',  array('q')));

        $this->assertEqual('like', $request->getAcceptRequest('apple'));
        $this->assertEqual('like', $request->getAcceptRequest('koala'));
        $this->assertEqual('post', $request->getAcceptRequest('method'));
        $this->assertNull($request->getAcceptRequest('car'));
        $this->assertNull($request->getAcceptRequest('first'));

        $this->assertEqual(
            'dislike', 
            $request->getAcceptRequest('mango', array('g', 'p', 'c', 'q')));
        $this->assertEqual(
            'dislike', 
            $request->getAcceptRequest('dog', array('g', 'p', 'c', 'q')));
        $this->assertEqual(
            'dislike', 
            $request->getAcceptRequest('jet', array('g', 'p', 'c', 'q')));
        $this->assertEqual(
            array('3', 'three'), 
            $request->getAcceptRequest('third', array('g', 'p', 'c', 'q')));

        $this->assertEqual(
            'query_string', 
            $request->getAcceptRequest('method', array('g', 'p', 'c', 'q')));
        $this->assertEqual(
            'cookie', 
            $request->getAcceptRequest('method', array('g', 'p', 'q', 'c')));
        $this->assertEqual(
            'post', 
            $request->getAcceptRequest('method', array('g', 'c', 'q', 'p')));
        $this->assertEqual(
            'get', 
            $request->getAcceptRequest('method', array('p', 'c', 'q', 'g')));
    }

    /**
     * Request::getPathInfo()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testGetPathInfo()
    {
        $request = new Request;

        $_SERVER['PATH_INFO'] = '/foo/1/bar/2/hoge/3';
        $this->assertEqual(
            array('foo' => 1, 'bar' => 2, 'hoge' => 3), 
            $request->getPathInfo());
    }

    /**
     * Request::getEnv()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testGetEnv()
    {
        $_SERVER = array(
                'HTTP_HOST'       => 'www.example.com', 
                'HTTP_REFERER'    => "\0http://www.example.com/index.\0php", 
                'HTTP_USER_AGENT' => 'Mozilla/4.0', 
            );

        $request = new Request;
        $this->assertEqual('www.example.com', $request->getEnv('HTTP_HOST'));
        $this->assertEqual(
            'http://www.example.com/index.php', 
            $request->getEnv('HTTP_REFERER'));
        $this->assertEqual('Mozilla/4.0', $request->getEnv('HTTP_USER_AGENT'));

        $this->assertNull($request->getEnv('REQUEST_METHOD'));
        $this->assertNull($request->getEnv('HTTPS'));
        $this->assertNull($request->getEnv('http_host'));
        $this->assertNull($request->getEnv('HTTP-HOST'));
    }

    /**
     * Request::getHost()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testGetHost()
    {
        $request = new Request;

        $this->assertEqual('', $request->getHost());

        $_SERVER = array('HTTP_HOST' => 'www.example.com');
        $this->assertEqual('www.example.com', $request->getHost());

        $_SERVER = array('HTTP_X_FORWARDED_HOST' => 'web.example.com');
        $this->assertEqual('web.example.com', $request->getHost());
    }

    /**
     * Request::getServerName()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testGetServerName()
    {
        $request = new Request;

        $this->assertEqual('', $request->getServerName());

        $_SERVER = array('SERVER_NAME' => 'www.example.com');
        $this->assertEqual('www.example.com', $request->getServerName());

        $_SERVER = array('HTTP_X_FORWARDED_SERVER' => 'web.example.com');
        $this->assertEqual('web.example.com', $request->getServerName());
    }

    /**
     * Request::getReferer()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testGetReferer()
    {
        $request = new Request;

        $this->assertEqual('', $request->getReferer());

        $_SERVER = array('HTTP_REFERER' => 'http://www.yahoo.co.jp/');
        $this->assertEqual('http://www.yahoo.co.jp/', $request->getReferer());
    }

    /**
     * Request::getScriptName()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testGetScriptName()
    {
        $request = new Request;

        $this->assertEqual('', $request->getScriptName());

        $_SERVER = array('SCRIPT_NAME' => '/example/sample.php');
        $this->assertEqual('/example/sample.php', $request->getScriptName());

        $_SERVER = array('ORIG_SCRIPT_NAME' => '/example/test.php');
        $this->assertEqual('/example/test.php', $request->getScriptName());
    }

    /**
     * Request::getMainPath()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testGetMainPath()
    {
        $request = new Request;

        $this->assertEqual('', $request->getMainPath());

        $_SERVER = array('SCRIPT_FILENAME' => '/example/sample.php');
        $this->assertEqual('/example/sample.php', $request->getMainPath());

        $_SERVER = array('ORIG_SCRIPT_FILENAME' => '/example/test.php');
        $this->assertEqual('/example/test.php', $request->getMainPath());
    }

    /**
     * Request::getScheme()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testGetScheme()
    {
        $request = new Request;

        $_SERVER = array('HTTPS' => 'on');
        $this->assertEqual('https:', $request->getScheme());

        $_SERVER = array('HTTPS' => '');
        $this->assertEqual('http:', $request->getScheme());
    }

    /**
     * Request::getHostUri()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testGetHostUri()
    {
        $request = new Request;

        $_SERVER = array(
                'HTTP_HOST' => 'www.example.com', 
                'HTTPS'     => 'on', 
            );
        $this->assertEqual('https://www.example.com', $request->getHostUri());

        $_SERVER = array(
                'HTTP_HOST'   => 'www.example.com', 
                'SERVER_NAME' => 'web.example.com', 
                'HTTPS'       => '', 
                'SERVER_PORT' => '8080', 
            );
        $this->assertEqual('http://www.example.com:8080', $request->getHostUri());

        $_SERVER = array(
                'SERVER_NAME' => 'web.example.com', 
                'HTTPS'       => 'on', 
                'SERVER_PORT' => '8081', 
            );
        $this->assertEqual('https://web.example.com:8081', $request->getHostUri());
    }

    /**
     * Request::getPathUri()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testGetPathUri()
    {
    }

    /**
     * Request::getUrl()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testGetUrl()
    {
    }

    /**
     * Request::getMethod()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testGetMethod()
    {
        $request = new Request;

        $_SERVER = array('REQUEST_METHOD' => 'POST');
        $this->assertEqual('POST', $request->getMethod());
        $_SERVER = array('REQUEST_METHOD' => 'GET');
        $this->assertEqual('GET', $request->getMethod());
        $_SERVER = array('REQUEST_METHOD' => 'PUT');
        $this->assertEqual('PUT', $request->getMethod());
        $_SERVER = array('REQUEST_METHOD' => 'DELETE');
        $this->assertEqual('DELETE', $request->getMethod());
        $_SERVER = array('REQUEST_METHOD' => 'HEAD');
        $this->assertEqual('HEAD', $request->getMethod());
        $_SERVER = array('REQUEST_METHOD' => '');
        $this->assertEqual('GET', $request->getMethod());
        $_SERVER = array('REQUEST_METHOD' => 'foo');
        $this->assertEqual('GET', $request->getMethod());
    }

    /**
     * Request::isPost()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testIsPost()
    {
        $request = new Request;

        $_SERVER = array('REQUEST_METHOD' => 'POST');
        $this->assertTrue($request->isPost());
        $this->assertFalse($request->isGet());
        $this->assertFalse($request->isPut());
        $this->assertFalse($request->isDelete());
        $this->assertFalse($request->isHead());
    }

    /**
     * Request::isGet()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testIsGet()
    {
        $request = new Request;

        $_SERVER = array('REQUEST_METHOD' => 'GET');
        $this->assertTrue($request->isGet());
        $this->assertFalse($request->isPost());
        $this->assertFalse($request->isPut());
        $this->assertFalse($request->isDelete());
        $this->assertFalse($request->isHead());

        $_SERVER = array('REQUEST_METHOD' => '');
        $this->assertTrue($request->isGet());

        $_SERVER = array('REQUEST_METHOD' => 'foo');
        $this->assertTrue($request->isGet());
    }

    /**
     * Request::isPut()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testIsPut()
    {
        $request = new Request;

        $_SERVER = array('REQUEST_METHOD' => 'PUT');
        $this->assertTrue($request->isPut());
        $this->assertFalse($request->isPost());
        $this->assertFalse($request->isGet());
        $this->assertFalse($request->isDelete());
        $this->assertFalse($request->isHead());
    }

    /**
     * Request::isDelete()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testIsDelete()
    {
        $request = new Request;

        $_SERVER = array('REQUEST_METHOD' => 'DELETE');
        $this->assertTrue($request->isDelete());
        $this->assertFalse($request->isPost());
        $this->assertFalse($request->isGet());
        $this->assertFalse($request->isPut());
        $this->assertFalse($request->isHead());
    }

    /**
     * Request::isHead()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testIsHead()
    {
        $request = new Request;

        $_SERVER = array('REQUEST_METHOD' => 'HEAD');
        $this->assertTrue($request->isHead());
        $this->assertFalse($request->isPost());
        $this->assertFalse($request->isGet());
        $this->assertFalse($request->isPut());
        $this->assertFalse($request->isDelete());
    }

    /**
     * Request::isSecure᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testIsSecure()
    {
        $request = new Request;

        $_SERVER = array('HTTPS' => 'on');
        $this->assertTrue($request->isSecure());

        $_SERVER = array('HTTPS' => '');
        $this->assertFalse($request->isSecure());

        $_SERVER = array('HTTP_X_FORWARDED_PROTO' => 'https');
        $this->assertTrue($request->isSecure());

    }
}

$test = &new Test_Request;
$test->run(new TextReporter);
