<?php

require_once 
    dirname(dirname(__FILE__)) . DIRECTORY_SEPARATOR . 'tima.php';

if (!defined('DS')) {
    define('DS', DIRECTORY_SEPARATOR);
}
if (!defined('SIMPLE_TEST')) {
    define('SIMPLE_TEST', dirname(__FILE__) . DS . 'simpletest');
}

require_once 
    SIMPLE_TEST . DS . 'unit_tester.php';
require_once
    SIMPLE_TEST . DS . 'reporter.php';

/**
 *  Response饹Υƥȥ
 */
class Test_Response extends UnitTestCase 
{

    /**
     * 󥹥ȥ饯
     * 
     * @access puclic
     */
    function Test_Response()
    {
        $this->UnitTestCase();

        require_once 
            dirname(dirname(__FILE__)) . DS . 'tima' . DS . 'Response.class.php';
    }

    /**
     * дĶѿ
     * 
     * @return void
     * @access puclic
     */
    function setup()
    {
        $_SERVER = array();
    }

    /**
     * 󥹥ȥ饯Υƥ
     * 
     * @return void
     * @access puclic
     */
    function testConstructor()
    {
        $response_a = &new Response;
        $this->assertEqual('HTTP/1.0 200 OK', $response_a->getStatus());


        $_SERVER = array('SERVER_PROTOCOL' => 'HTTP/1.1');
        $response_b = &new Response;
        $this->assertEqual('HTTP/1.1 200 OK', $response_b->getStatus());

        $_SERVER = array('SERVER_PROTOCOL' => 'HTTP/9.9');
        $response_c = &new Response;
        $this->assertEqual('HTTP/9.9 200 OK', $response_c->getStatus());

        $_SERVER = array('SERVER_PROTOCOL' => 'HTTP/10.0');
        $response_d = &new Response;
        $this->assertEqual('HTTP/1.0 200 OK', $response_d->getStatus());

        $_SERVER = array('SERVER_PROTOCOL' => 'HTTP/3.');
        $response_e = &new Response;
        $this->assertEqual('HTTP/1.0 200 OK', $response_e->getStatus());

        $_SERVER = array('SERVER_PROTOCOL' => 'HTTP/a.1');
        $response_f = &new Response;
        $this->assertEqual('HTTP/1.0 200 OK', $response_f->getStatus());
    }

    /**
     * Response::setStatus()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testSetStatus()
    {
        $response = new Response;

        $response->setStatus('500');
        $this->assertEqual(
            'HTTP/1.0 500 Internal Server Error', 
            $response->getStatus());

        $response->setStatus('400');
        $this->assertEqual(
            'HTTP/1.0 400 Bad Request', 
            $response->getStatus());

        $response->setStatus('500', 'Unknow Error');
        $this->assertEqual(
            'HTTP/1.0 500 Unknow Error', 
            $response->getStatus());

        $response->setStatus('239', 'Thanks');
        $this->assertEqual(
            'HTTP/1.0 239 Thanks', 
            $response->getStatus());

        $response->setStatus('239');
        $this->assertEqual(
            'HTTP/1.0 239', 
            $response->getStatus());
    }

    /**
     * Response::setContentType()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testSetContentType()
    {
        $response = new Response;

        $response->setContentType('text/css', 'utf-8');
        $this->assertEqual(
            'text/css; charset=UTF-8', 
            $response->getHeader('content-type'));

        $response->setContentType('image/jpeg');
        $this->assertEqual('image/jpeg', $response->getHeader('content-type'));

        $response->setContentType('application/pdf');
        $this->assertEqual('application/pdf', $response->getHeader('content-type'));
    }

    /**
     * Response::setCacheControl(()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testSetCacheControl()
    {
        $response = new Response;
        $response->setCacheControl('no-store');
        $response->setCacheControl('no-cache');
        $response->setCacheControl('must-revalidate');
        $response->setCacheControl('pre-check', 10);
        $response->setCacheControl('post-check', 10);
        $this->assertEqual(
            'no-store, no-cache, must-revalidate, pre-check=10, post-check=10', 
            $response->getHeader('cache-control'));
    }

    /**
     * Response::setHeader()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testSetHeader()
    {
        $response = new Response;

        $response->setHeader('age', 600);
        $this->assertEqual('600', $response->getHeader('age'));

        $response->setHeader('AGE', 100);
        $this->assertEqual('100', $response->getHeader('age'));

        $response->setHeader('location', 'http://google.com');
        $this->assertEqual('http://google.com', $response->getHeader('location'));

        $response->setHeader('Location', 'http://yahoo.co.jp');
        $this->assertEqual('http://yahoo.co.jp', $response->getHeader('location'));

        // ºݤˤϡETagפEtagפˤʤäƤ
        // ŪХ
        $response->setHeader('ETag', 'usagi-1234');
        $this->assertEqual('usagi-1234', $response->getHeader('ETag'));
    }

    /**
     * Response::getHeader()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testGetHeader()
    {
        $response = new Response;

        $response->setHeader('age', 600);
        $this->assertEqual('600', $response->getHeader('age'));
        $this->assertEqual('600', $response->getHeader('Age'));
        $this->assertEqual('600', $response->getHeader('AGE'));

        $response->removeHeader('age');
        $this->assertEqual('', $response->getHeader('age'));
    }

    /**
     * Response::removeHeader()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testRemoveHeader()
    {
        $response = new Response;

        $response->setHeader('expires', 'Wed, 13 Feb 2008 0:00:00 GMT');
        $response->removeHeader('expires');
        $this->assertEqual('', $response->getHeader('expires'));

        $response->setContentType('text/css', 'utf-8');
        $response->removeHeader('content-type');
        $this->assertEqual('', $response->getHeader('content-type'));

        $response->setCacheControl('no-store');
        $response->setCacheControl('no-cache');
        $response->removeHeader('cache-control');
        $this->assertEqual('', $response->getHeader('cache-control'));
    }

    /**
     * Response::isHeaderExists()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testIsHeaderExists()
    {
        $response = new Response;

        $this->assertFalse($response->isHeaderExists('age'));
        $this->assertFalse($response->isHeaderExists('content-type'));
        $this->assertFalse($response->isHeaderExists('cache-control'));

        $response->setHeader('age', 600);
        $this->assertTrue($response->isHeaderExists('age'));

        $response->setContentType('text/css', 'utf-8');
        $this->assertTrue($response->isHeaderExists('content-type'));

        $response->setCacheControl('no-cache');
        $this->assertTrue($response->isHeaderExists('cache-control'));

        $response->removeHeader('age');
        $this->assertFalse($response->isHeaderExists('age'));

        $response->removeHeader('content-type');
        $this->assertFalse($response->isHeaderExists('content-type'));

        $response->removeHeader('no-cache');
        $this->assertFalse($response->isHeaderExists('no-cache'));
    }

    /**
     * Response::clearHeader()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testClearHeader()
    {
        $response = new Response;

        $response->setHeader('age', 600);
        $response->setContentType('text/css', 'utf-8');
        $response->setCacheControl('no-cache');

        $response->clearHeader();
        $this->assertFalse($response->isHeaderExists('age'));
        $this->assertFalse($response->isHeaderExists('content-type'));
        $this->assertFalse($response->isHeaderExists('cache-control'));
    }

    /**
     * Response::setDataModel() / Response::getDataModel() ᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testSetDataModel()
    {
        $response = new Response;

        $response->setDataModel('saint', 'Seiya');
        $response->setDataModel('cloth', 'Pegasus');
        $this->assertEqual(
            array('saint' => 'Seiya', 'cloth' => 'Pegasus'), 
            $response->getDataModel());

        $response->setDataModel('saint', 'Hyouga');
        $response->setDataModel('cloth', 'Kygnus');
        $response->setDataModel('teacher', 'Camus');
        $this->assertEqual(
            array('saint' => 'Hyouga', 'cloth' => 'Kygnus', 'teacher' => 'Camus'), 
            $response->getDataModel());
    }

    /**
     * Response::setContents() / Response::flush()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testSetContents()
    {
        $response = new Response;

        $response->setContents('ϥƥȤʸ');

        ob_start();
        @$response->flush();
        $output = ob_get_contents();
        ob_end_clean();
        $this->assertEqual('ϥƥȤʸ', $output);

        $response->setContents('ʸϤƤѹƽϥƥ');

        ob_start();
        @$response->flush();
        $output = ob_get_contents();
        ob_end_clean();
        $this->assertEqual('ʸϤƤѹƽϥƥ', $output);
    }
}

$test = &new Test_Response;
$test->run(new TextReporter);
