<?php

require_once 
    dirname(dirname(__FILE__)) . DIRECTORY_SEPARATOR . 'tima.php';

if (!defined('DS')) {
    define('DS', DIRECTORY_SEPARATOR);
}
if (!defined('SIMPLE_TEST')) {
    define('SIMPLE_TEST', dirname(__FILE__) . DS . 'simpletest');
}

require_once 
    SIMPLE_TEST . DS . 'unit_tester.php';
require_once
    SIMPLE_TEST . DS . 'reporter.php';

/**
 *  UserAgent饹Υƥȥ
 */
class Test_UserAgent extends UnitTestCase 
{

    /**
     * DoCoMoΥ桼
     * 
     * @var    array
     * @access private
     */
    var $_docomoUA = array();

    /**
     * auΥ桼
     * 
     * @var    array
     * @access private
     */
    var $_auUA = array();

    /**
     * SoftBankΥ桼
     * 
     * @var    array
     * @access private
     */
    var $_softbankUA = array();

    /**
     * üʳΥ桼
     * 
     * @var    array
     * @access private
     */
    var $_nonMobileUA = array();

    /**
     * 󥹥ȥ饯
     * 
     * @access puclic
     */
    function Test_UserAgent()
    {
        $this->UnitTestCase();

        require_once 
            dirname(dirname(__FILE__)) . DS . 'tima' . DS . 'UserAgent.class.php';
    }

    /**
     * UA
     * 
     * @return void
     * @access puclic
     */
    function setup()
    {
        $this->_docomoUA = array(
                'P501i'    => 'DoCoMo/1.0/P501i', 
                'SO502iWM' => 'DoCoMo/1.0/SO502iWM', 
                'ER209i'   => 'DoCoMo/1.0/ER209i', 
                'P651ps'   => 'DoCoMo/1.0/P651ps', 
                'KO210i'   => 'DoCoMo/1.0/KO210i', 
                'N2002'    => 'DoCoMo/2.0/N2002', 
                'N900iG'   => 'DoCoMo/2.0/N900iG', 
                'SO902iWP' => 'DoCoMo/2.0/SO902iWP', 
                'F882iES'  => 'DoCoMo/2.0/F882iES', 
                'P704imyu' => 'DoCoMo/2.0 P704imyu', 
                'F883iES'  => 'DoCoMo/2.0 F883iES', 
            );
        $this->_auUA = array(
                'CA13' => 'UP.Browser/3.04-CA13 UP.Link/3.4.4', 
                'SY14' => 'UP.Browser/3.04-SY14 UP.Link/3.4.5.6', 
                'TS21' => 'KDDI-TS21 UP.Browser/6.0.5.287 (GUI) MMP/1.1', 
                'KC3A' => 'KDDI-KC3A UP.Browser/6.2.0.12.1.3 (GUI) MMP/2.0', 
                'KCT2' => 'UP.Browser/3.03-KCT2/KCT3 UP.Link/3.4.5.6', 
                'MAT1' => 'UP.Browser/3.04-MAT1/MAT2 UP.Link/3.4.4', 
                'KCTD' => 'UP.Browser/3.04-KCTD UP.Link/3.2.1.2', 
                'KCU1' => 'KDDI-KCU1 UP.Browser/6.2.0.5.1 (GUI) MMP/2.0', 
            );

        $this->_softbankUA = array(
                'J-SH02'  => 'J-PHONE/2.0/J-SH02', 
                'J-SH04'  => 'J-PHONE/3.0/J-SH04', 
                'V301T'   => 'J-PHONE/3.0/V301T', 
                'J-SH10'  => 'J-PHONE/3.0/J-SH10', 
                'V401SH'  => 'J-PHONE/3.0/V401SH', 
                'J-P51'   => 
                    'J-PHONE/4.0/J-P51/SNXXXXXXXXX ' . 
                    'MA/JDP51A36 Profile/MIDP-1.0 ' . 
                    'Configuration/CLDC-1.0 ' . 
                    'Ext-Profile/JSCL-1.1.0', 
                'V601N'   => 
                    'J-PHONE/4.2/V601N/SNXXXXXXXXX ' . 
                    'N/01000100 Profile/MIDP-1.0 ' . 
                    'Configuration/CLDC-1.0 ' . 
                    'Ext-Profile/JSCL-1.1.1', 
                'J-SH53'  => 
                    'J-PHONE/4.2/J-SH53/SNXXXXXXXXX ' . 
                    'SH/0003aa Profile/MIDP-1.0 ' . 
                    'Configuration/CLDC-1.0 ' . 
                    'Ext-Profile/JSCL-1.2.1', 
                'V601SH'  => 
                    'J-PHONE/4.2/V601SH/SNXXXXXXXXX ' . 
                    'SH/0004aa Profile/MIDP-1.0 ' . 
                    'Configuration/CLDC-1.0 ' . 
                    'Ext-Profile/JSCL-1.2.1', 
                'V602T'   => 
                    'J-PHONE/4.3/V602T/SNXXXXXXXXX ' . 
                    'TS/2.00 Profile/MIDP-1.0 ' . 
                    'Configuration/CLDC-1.0 ' . 
                    'Ext-Profile/JSCL-1.2.2', 
                'V501T'   => 
                    'J-PHONE/4.3/V501T/SNXXXXXXXXX ' . 
                    'TS/2.00 Profile/MIDP-1.0?@' . 
                    'Configuration/CLDC-1.0?@' . 
                    'Ext-Profile/JSCL-1.3.2', 
                'V801SH'  => 
                    'J-PHONE/5.0/V801SH/SNXXXXXXXXX ' . 
                    'SH/0005aa Profile/MIDP-1.0 ' . 
                    'Configuration/CLDC-1.0 ' . 
                    'Ext-Profile/JSCL-1.1.0', 
                '910SH'   => 
                    'SoftBank/1.0/910SH/SHJ001/SNXXXXXXXXX ' . 
                    'Browser/NetFront/3.3 ' . 
                    'Profile/MIDP-2.0 ' . 
                    'Configuration/CLDC-1.1', 
            );

        $this->_nonMobileUA = array(
                'ie'       => 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)', 
                'opera'    => '8.0 (Windows NT 5.1; U; en)', 
                'netscape' => '4.8 [en] (Windows NT 5.1; U)', 
                'google'   => 'Googlebot/2.1 (+http://www.google.com/bot.html)', 
                'yahoo'    => 
                    'Mozilla/5.0 (compatible; Yahoo! Slurp; ' . 
                    'http://help.yahoo.com/help/us/ysearch/slurp)', 
                'AirEDGE'  => 
                    'Mozilla/3.0(DDIPOCKET;' . 
                    'JRC/AH-J3001V,AH-J3002V/1.0/0100/c50)CNF/2.0', 
                'H"'       => 'PDXGW/1.0 (TX=8;TY=6;GX=96;GY=64;C=G2;G=B2;GI=0)', 
                'ASTEL'    => 'ASTEL/1.0/J-0511.00/c10/smel', 
                'novalue'  => '', 
                'unknow'   => 'Mo2i11a/4.o (Foo; M21E 7.0; Wind0ws HT 5.1)', 
            );
    }

    /**
     * UserAgent::getInstance()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testGetInstance()
    {
        $this->assertIsA(UserAgent::getInstance(), 'UserAgent');

        $useragent_a = &UserAgent::getInstance();
        $useragent_b = &UserAgent::getInstance();
        $this->assertIdentical($useragent_a, $useragent_b);

        $useragent_a = null;
        $this->assertNull($useragent_b);
    }

    /**
     * UserAgent::isMobile()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testIsMobile()
    {
        foreach ($this->_nonMobileUA as $name => $value) {
            $_SERVER['HTTP_USER_AGENT'] = $value;
            $useragent = new UserAgent;
            $this->assertFalse($useragent->isMobile(), "UA: ${name}");
        }

        foreach ($this->_docomoUA as $name => $value) {
            $_SERVER['HTTP_USER_AGENT'] = $value;
            $useragent = new UserAgent;
            $this->assertTrue($useragent->isMobile(), "UA: ${name}");
        }
        foreach ($this->_auUA as $name => $value) {
            $_SERVER['HTTP_USER_AGENT'] = $value;
            $useragent = new UserAgent;
            $this->assertTrue($useragent->isMobile(), "UA: ${name}");
        }
        foreach ($this->_softbankUA as $name => $value) {
            $_SERVER['HTTP_USER_AGENT'] = $value;
            $useragent = new UserAgent;
            $this->assertTrue($useragent->isMobile(), "UA: ${name}");
        }
    }

    /**
     * UserAgent::isDoCoMo()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testIsDoCoMo()
    {
        foreach ($this->_docomoUA as $name => $value) {
            $_SERVER['HTTP_USER_AGENT'] = $value;
            $useragent = new UserAgent;
            $this->assertTrue($useragent->isDoCoMo(), "UA: ${name}");
        }

        foreach ($this->_auUA as $name => $value) {
            $_SERVER['HTTP_USER_AGENT'] = $value;
            $useragent = new UserAgent;
            $this->assertFalse($useragent->isDoCoMo(), "UA: ${name}");
        }
        foreach ($this->_softbankUA as $name => $value) {
            $_SERVER['HTTP_USER_AGENT'] = $value;
            $useragent = new UserAgent;
            $this->assertFalse($useragent->isDoCoMo(), "UA: ${name}");
        }
        foreach ($this->_nonMobileUA as $name => $value) {
            $_SERVER['HTTP_USER_AGENT'] = $value;
            $useragent = new UserAgent;
            $this->assertFalse($useragent->isDoCoMo(), "UA: ${name}");
        }
    }

    /**
     * UserAgent::isEZweb()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testIsEZweb()
    {
        foreach ($this->_auUA as $name => $value) {
            $_SERVER['HTTP_USER_AGENT'] = $value;
            $useragent = new UserAgent;
            $this->assertTrue($useragent->isEZweb(), "UA: ${name}");
        }

        foreach ($this->_docomoUA as $name => $value) {
            $_SERVER['HTTP_USER_AGENT'] = $value;
            $useragent = new UserAgent;
            $this->assertFalse($useragent->isEZweb(), "UA: ${name}");
        }
        foreach ($this->_softbankUA as $name => $value) {
            $_SERVER['HTTP_USER_AGENT'] = $value;
            $useragent = new UserAgent;
            $this->assertFalse($useragent->isEZweb(), "UA: ${name}");
        }
        foreach ($this->_nonMobileUA as $name => $value) {
            $_SERVER['HTTP_USER_AGENT'] = $value;
            $useragent = new UserAgent;
            $this->assertFalse($useragent->isEZweb(), "UA: ${name}");
        }
    }

    /**
     * UserAgent::isSoftBank()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testIsSoftBank()
    {
        foreach ($this->_softbankUA as $name => $value) {
            $_SERVER['HTTP_USER_AGENT'] = $value;
            $useragent = new UserAgent;
            $this->assertTrue($useragent->isSoftBank(), "UA: ${name}");
        }

        foreach ($this->_docomoUA as $name => $value) {
            $_SERVER['HTTP_USER_AGENT'] = $value;
            $useragent = new UserAgent;
            $this->assertFalse($useragent->isSoftBank(), "UA: ${name}");
        }
        foreach ($this->_auUA as $name => $value) {
            $_SERVER['HTTP_USER_AGENT'] = $value;
            $useragent = new UserAgent;
            $this->assertFalse($useragent->isSoftBank(), "UA: ${name}");
        }
        foreach ($this->_nonMobileUA as $name => $value) {
            $_SERVER['HTTP_USER_AGENT'] = $value;
            $useragent = new UserAgent;
            $this->assertFalse($useragent->isSoftBank(), "UA: ${name}");
        }
    }

    /**
     * UserAgent::isDoCoMo()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testGetModel()
    {
        foreach ($this->_docomoUA as $name => $value) {
            $_SERVER['HTTP_USER_AGENT'] = $value;
            $useragent = new UserAgent;
            $this->assertEqual($name, $useragent->getModel());
        }
        foreach ($this->_auUA as $name => $value) {
            $_SERVER['HTTP_USER_AGENT'] = $value;
            $useragent = new UserAgent;
            $this->assertEqual($name, $useragent->getModel());
        }
        foreach ($this->_softbankUA as $name => $value) {
            $_SERVER['HTTP_USER_AGENT'] = $value;
            $useragent = new UserAgent;
            $this->assertEqual($name, $useragent->getModel());
        }

        foreach ($this->_nonMobileUA as $name => $value) {
            $_SERVER['HTTP_USER_AGENT'] = $value;
            $useragent = new UserAgent;
            $this->assertEqual('unknow', $useragent->getModel());
        }
    }
}

$test = &new Test_UserAgent;
$test->run(new TextReporter);
