<?php

require_once 
    dirname(dirname(__FILE__)) . DIRECTORY_SEPARATOR . 'tima.php';

if (!defined('DS')) {
    define('DS', DIRECTORY_SEPARATOR);
}
if (!defined('SIMPLE_TEST')) {
    define('SIMPLE_TEST', dirname(__FILE__) . DS . 'simpletest');
}

require_once 
    SIMPLE_TEST . DS . 'unit_tester.php';
require_once
    SIMPLE_TEST . DS . 'reporter.php';

/**
 *  Utility饹Υƥȥ
 */
class Test_Utility extends UnitTestCase 
{

    /**
     * SQLiteե
     * 
     * @var    string
     * @access private
     */
    var $_dbPath = '';

    /**
     * DSN
     * 
     * @var    string
     * @access private
     */
    var $_dsn = '';

    /**
     * 󥹥ȥ饯
     * 
     * @access puclic
     */
    function Test_Utility()
    {
        $this->UnitTestCase();

        require_once 
            dirname(dirname(__FILE__)) . DS . 'tima' . DS . 'Utility.class.php';
    }

    /**
     * Utility::camelize()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testCamelize()
    {
        $this->assertEqual('Foo', Utility::camelize('foo'));
        $this->assertEqual('ThisIsAPen', Utility::camelize('This is a pen'));
        $this->assertEqual('FooBar', Utility::camelize('foo_bar'));
        $this->assertEqual('HtmlToXhtml', Utility::camelize('HTML to XHTML'));
        $this->assertEqual('Hira2Kana', Utility::camelize('hira_2_kana'));
    }

    /**
     * Utility::merge()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testMerge()
    {
        $this->assertEqual(array('a', 'b'), Utility::merge(array('a'), array('b')));
        $this->assertEqual(array('b', 'a'), Utility::merge(array('b'), array('a')));

        $this->assertEqual(
            array('1', '2', '3', '4', '5'), 
            Utility::merge(array('1', '2'), array('3', '4', '5')));

        $to_big = array('a' => 'A', 'b' => 'B', 'c' => 'C');
        $to_num = array('a' => '1', 'b' => '2', 'c' => '3');
        $this->assertEqual(
            array('a' => '1', 'b' => '2', 'c' => '3'), 
            Utility::merge($to_big, $to_num));
        $this->assertEqual(
            array('a' => 'A', 'b' => 'B', 'c' => 'C'), 
            Utility::merge($to_num, $to_big));

        $to_array = array('a' => array('A'), 'b' => array('B'), 'c' => array('C'));
        $this->assertEqual(
            array('a' => array('A'), 'b' => array('B'), 'c' => array('C')), 
            Utility::merge($to_big, $to_array));
        $this->assertEqual(
            array('a' => 'A', 'b' => 'B', 'c' => 'C'), 
            Utility::merge($to_array, $to_big));
        $this->assertEqual(
            array(
                    'a' => array('A', 'A'), 
                    'b' => array('B', 'B'), 
                    'c' => array('C', 'C')
                ), 
            Utility::merge($to_array, $to_array));

        $this->assertEqual(
            array('1', '2', 'a' => '1', 'b' => '2'), 
            Utility::merge(array('1', '2'), array('a' => '1', 'b' => '2')));
        $this->assertEqual(
            array('a' => '1', 'b' => '2', '1', '2'), 
            Utility::merge(array('a' => '1', 'b' => '2'), array('1', '2')));

        $this->assertEqual(
            array('a' => array('a' => array('a' => array('1'), 'b' => array('2')))), 
            Utility::merge(
                array('a' => array('a' => array('a' => array('1')))), 
                array('a' => array('a' => array('b' => array('2'))))));
        $this->assertEqual(
            array('a' => array('a' => array('a' => array('1', '2')))), 
            Utility::merge(
                array('a' => array('a' => array('a' => array('1')))), 
                array('a' => array('a' => array('a' => array('2'))))));
        $this->assertEqual(
            array('a' => array('a' => array('a' => array('1')), 'b' => '1')), 
            Utility::merge(
                array('a' => array('a' => array('a' => array('1')))), 
                array('a' => array('b' => '1'))));
        $this->assertEqual(
            array('a' => array('a' => array('a' => '1'))), 
            Utility::merge(
                array('a' => array('a' => array('a' => array('1')))), 
                array('a' => array('a' => array('a' => '1')))));

        $this->assertEqual(
            array(
                    'name'     => 'bar', 
                    'age'      => '27', 
                    'gender'   => 'man', 
                    'birthday' => '2000-01-23', 
                ), 
            Utility::merge(
                array('name' => 'foo', 'age' => '26'), 
                array('gender' => 'man', 'age' => '27'), 
                array('name' => 'bar', 'birthday' => '2000-01-23')));

        $user = array(
                'personal' => array(
                        'name' => 'foo bar', 
                        'age'  => '50', 
                        'job'  => 'play'
                    ), 
                'account' => array(
                        'permission' => 'user', 
                        'last-logon' => '2000-12-03', 
                        'space'      => 'dream', 
                    ), 
            );
        $manager = array(
                'personal' => array(
                        'job'  => 'work'
                    ), 
                'account' => array(
                        'permission' => 'admin', 
                        'num-logon'  => '120', 
                    ), 
                'works' => array(
                        'update', 
                        'update', 
                        'delete', 
                        'update', 
                        'insert', 
                        'update', 
                    ), 
            );
        $this->assertEqual(
            array(
                    'personal' => array(
                            'name' => 'foo bar', 
                            'age' => '50', 
                            'job' => 'work'
                        ), 
                    'account' => array(
                            'permission' => 'admin', 
                            'last-logon' => '2000-12-03', 
                            'space'      => 'dream', 
                            'num-logon'  => '120', 
                        ), 
                    'works' => array(
                            'update', 
                            'update', 
                            'delete', 
                            'update', 
                            'insert', 
                            'update', 
                        ), 
                ), 
            Utility::merge($user, $manager));
    }

    /**
     * Utility::isMatch()᥽åɤΥƥ
     * 
     * @return void
     * @access puclic
     */
    function testIsMatch()
    {
    }
}

$test = &new Test_Utility;
$test->run(new TextReporter);
