<?php

/**
 * The tiny modules for web application
 * - PHP versions 4 -
 * 
 * @category  web application framework
 * @package   tima
 * @author    IKEDA Youhey <youhey.ikeda@gmail.com>
 * @license   http://www.apache.org/licenses/LICENSE-2.0 Apache License, Version 2.0
 * @copyright 2007 IKEDA Youhey
 *     Licensed under the Apache License, Version 2.0 (the "License"); 
 *     you may not use this file except in compliance with the License. 
 *     You may obtain a copy of the License at 
 *         http://www.apache.org/licenses/LICENSE-2.0 
 *     Unless required by applicable law or agreed to in writing, software 
 *     distributed under the License is distributed on an "AS IS" BASIS, 
 *     WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 *     See the License for the specific language governing permissions and 
 *     limitations under the License.
 * @version  1.0.0
 */

/**
 * 󡦥ȥΥѡ饹
 * 
 * - ץΥե
 * - дؿǥ
 *  - ǥꥯȤΥå¹
 *  - ưǤдؿ
 *   - entry
 *   - execute¹Խ
 *   - exit
 *   - validateڽ
 * 
 * @package    tima
 * @subpackage tima_Action
 * @author     IKEDA Youhey <youhey.ikeda@gmail.com>
 */
class Action
{
    /**
     * ưϻ
     * 
     * @var    float
     * @access public
     */
    var $beginning = 0.0;

    /**
     * ǥեȡ̾
     * 
     * @var    string
     * @access protected
     */
    var $defaultAction = 'default';

    /**
     * 
     * 
     * @var    Question
     * @access protected
     */
    var $question = null;

    /**
     * ꥯ
     * 
     * @var    Request
     * @access protected
     */
    var $request = null;

    /**
     * 쥹ݥ
     * 
     * @var    Response
     * @access protected
     */
    var $response = null;

    /**
     * 桼
     * 
     * @var    UserAgent
     * @access protected
     */
    var $userAgent = null;

    /**
     * å
     * 
     * @var    Session
     * @access protected
     */
    var $session = null;

    /**
     * եȡȥ
     * 
     * @var    Front
     * @access protected
     */
    var $front = null;

    /**
     * 
     * 
     * @var    Logger
     * @access protected
     */
    var $logger = null;

    /**
     * ʤprotected˥ѿѿ̾
     * - ݸѿѿ̾
     * - ʼʤprotectedʤʬŤ餤׸Ƥ
     * 
     * @var    array
     * @access protected
     */
    var $protectedVarNames = array(
            'defaultAction', 
            'question', 
            'request', 
            'response', 
            'userAgent', 
            'session', 
            'logger', 
            'front', 
        );

    /**
     * 󥹥ȥ饯
     * 
     * @param  Front $front եȡȥ
     * @access public
     */
    function Action(&$front)
    {
        $this->session   = &new Session($this->getName());
        $this->front     = &$front;
        $this->request   = &$front->getRequest();
        $this->response  = &$front->getResponse();
        $this->userAgent = &$front->getUserAgent();
        $this->logger    = &$front->getLogger();
        $this->question  = &new Question($this);
        $this->beginning = $front->getBeginning();
    }

    /**
     * ȥ
     * 
     * @return void
     * @access public
     */
    function initialize() {}

    /**
     * ȥμ¹Ը¤ֵ
     * - ѡ饹ǤϾ˿
     * - Ѿ饹Ǿ˱֤褦С饤
     * 
     * @return boolean
     * @access public
     */
    function enable()
    {
        return true;
    }

    /**
     * Ƥ뤫򸡺
     * 
     * @param  string  $action ̾
     * @return boolean
     * @access public
     */
    function isActionExists($action)
    {
        return 
            method_exists($this, 'execute'.$action);
    }

    /**
     * ¹
     * 
     * @param  string $action_name
     * @return string
     * @access public
     */
    function invoke($action_name)
    {
        // ư륢̾
        $this->ACTIVE_ACTION = $action_name;

        // 
        $entry_method = 'entry'.$action_name;
        if (method_exists($this, $entry_method)) {
            call_user_func(array(&$this, $entry_method));
        }

        // ¹Խ
        $execute_method = 'execute'.$action_name;
        if (!method_exists($this, $execute_method)) {
            trigger_error(
                "Unable to execute the action '${action_name}'", E_USER_WARNING);
        } else {
            $reply = call_user_func(array(&$this, $execute_method));
        }

        // ƥץ졼ȤΥǡǥϿ
        foreach ($this->getProperties() as $varkey => $varvalue) {
            $this->response->setDataModel($varkey, $varvalue);
        }
        $this->response->setDataModel('form', $this->question->toArray());

        // 
        $exit_method = 'exit'.$action_name;
        if (method_exists($this, $exit_method)) {
            call_user_func(array(&$this, $exit_method));
        }

        return $reply;
    }

    /**
     * ǥեȡֵ̾
     * 
     * @return string
     * @access public
     */
    function getDefaultAction()
    {
        return $this->defaultAction;
    }

    /**
     * Ĥѿֵ
     * 
     * @return array
     * @access public
     */
    function getProperties()
    {
        $public_properties = array();
        foreach (array_keys(get_object_vars($this)) as $varkey) {
            if (strpos($varkey, '_') === 0) {
                continue;
            }
            if (in_array($varkey, $this->protectedVarNames)) {
                continue;
            }
            $public_properties[$varkey] = $this->$varkey;
        }

        return $public_properties;
    }

    /**
     * 󡦥ȥʼʡˤֵ̾
     * - ̾ϼºݤΥ饹̾˴طʤɬʸˤʤޤ
     *  - PHP4/5ɤǤƱֵͤѤ뤿
     * 
     * @return string
     * @access protected
     * @static string $ctrl_name
     */
    function getName()
    {
        static $ctrl_name;
        if (!isset($ctrl_name)) {
            $ctrl_name = 
                preg_match('/^(?:Action_)([\w]+)$/i', get_class($this), $match) ?
                    $match[1] : get_class($this);
        }

        // PHP4/5κۼ뤿strtolower()ؿǾʸѴ
        return 
            strtolower($ctrl_name);
    }
}
