<?php

/**
 * The tiny modules for web application
 * - PHP versions 4 -
 * 
 * @category  web application framework
 * @package   tima
 * @author    IKEDA Youhey <youhey.ikeda@gmail.com>
 * @license   http://www.apache.org/licenses/LICENSE-2.0 Apache License, Version 2.0
 * @copyright 2007 IKEDA Youhey
 *     Licensed under the Apache License, Version 2.0 (the "License"); 
 *     you may not use this file except in compliance with the License. 
 *     You may obtain a copy of the License at 
 *         http://www.apache.org/licenses/LICENSE-2.0 
 *     Unless required by applicable law or agreed to in writing, software 
 *     distributed under the License is distributed on an "AS IS" BASIS, 
 *     WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 *     See the License for the specific language governing permissions and 
 *     limitations under the License.
 * @version  1.0.0
 */

/**
 * ꥯȤ˴ޤޤʸե륿
 * 
 * @package    tima
 * @subpackage tima_Filter
 * @author     IKEDA Youhey <youhey.ikeda@gmail.com>
 */
class Filter_ClearCtrlChar
{

    /**
     * ꥯȤ˴ޤޤʸƾ
     *
     * @params Front $front
     * @return void
     * @access public
     */
    function before(&$front)
    {
        $logger = &$front->getLogger();

        $request = &$front->getRequest();
        foreach ($request->getAll() as $varkey => $varvalue) {
            $this->bridgeRecursive($varvalue);
            $request->set($varkey, $varvalue);
            $logger->trace("Erased the control-character: ${varkey}");
        }
        $logger->debug('Request was erased the control-character');

        $logger->trace('Executed pre filtering: '.__CLASS__);
    }

    /**
     * array_walk()ؿǽ뤿ΥХåؿ
     * 
     * Ѵ⥸塼ΡEraseCtrlChar׵ǽͤѴ
     * ͤϻȤǼäͤ˾
     *
     * @params mixed $varvalue
     * @params mixed $varkey
     * @return void
     * @access public
     */
    function bridgeRecursive(&$varvalue, $varkey = null)
    {
        if (is_array($varvalue)) {
            array_walk($varvalue, array(&$this, __FUNCTION__));
        } else {
            $varvalue = Utility::to('EraseCtrlChar', $varvalue);
        }
    }
}
