<?php

/**
 * The tiny modules for web application
 * - PHP versions 4 -
 * 
 * @category  web application framework
 * @package   tima
 * @author    IKEDA Youhey <youhey.ikeda@gmail.com>
 * @license   http://www.apache.org/licenses/LICENSE-2.0 Apache License, Version 2.0
 * @copyright 2007 IKEDA Youhey
 *     Licensed under the Apache License, Version 2.0 (the "License"); 
 *     you may not use this file except in compliance with the License. 
 *     You may obtain a copy of the License at 
 *         http://www.apache.org/licenses/LICENSE-2.0 
 *     Unless required by applicable law or agreed to in writing, software 
 *     distributed under the License is distributed on an "AS IS" BASIS, 
 *     WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 *     See the License for the specific language governing permissions and 
 *     limitations under the License.
 * @version  1.0.0
 */

/**
 * å̵Υإå
 * 
 * @package    tima
 * @subpackage tima_Filter
 * @author     IKEDA Youhey <youhey.ikeda@gmail.com>
 */
class Filter_NoCache
{

    /**
     * å̵Υإå
     *
     * @params Front $front
     * @return void
     * @access public
     */
    function before(&$front)
    {
        $logger = &$front->getLogger();

        $response = &$front->getResponse();
        $response->setHeader('Expires', '-1');
        $response->setHeader('Pragma', 'no-cache');
        $response->setCacheControl('private');
        $response->setCacheControl('max-age', '0');
        $response->setCacheControl('no-store');
        $response->setCacheControl('no-cache');
        $response->setCacheControl('must-revalidate');
        $response->setCacheControl('pre-check', '0');
        $response->setCacheControl('post-check', '0');

        $logger->trace('Executed pre filtering: '.__CLASS__);
    }
}
