<?php

/**
 * The tiny modules for web application
 * - PHP versions 4 -
 * 
 * @category  web application framework
 * @package   tima
 * @author    IKEDA Youhey <youhey.ikeda@gmail.com>
 * @license   http://www.apache.org/licenses/LICENSE-2.0 Apache License, Version 2.0
 * @copyright 2007 IKEDA Youhey
 *     Licensed under the Apache License, Version 2.0 (the "License"); 
 *     you may not use this file except in compliance with the License. 
 *     You may obtain a copy of the License at 
 *         http://www.apache.org/licenses/LICENSE-2.0 
 *     Unless required by applicable law or agreed to in writing, software 
 *     distributed under the License is distributed on an "AS IS" BASIS, 
 *     WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 *     See the License for the specific language governing permissions and 
 *     limitations under the License.
 * @version  1.0.0
 */

/**
 * ꥯȤФ򥵥ݡȤ뤿Υ饹
 * 
 * HTTPإå층뤿Ω饹
 * åѤ褦ǤСΥ饹ޤϷѾ饹˵ǽ
 * 
 * @package    tima
 * @subpackage tima_Response
 * @author     IKEDA Youhey <youhey.ikeda@gmail.com>
 */
class Response
{

    /**
     * HTTPإå
     * 
     * @var    array
     * @access private
     */
    var $_headerFields = array();

    /**
     * ܥǥѡ
     * 
     * @var    string
     * @access private
     */
    var $_contents = '';

    /**
     * ƥץ졼ȤΥǡǥ
     * 
     * @var    array
     * @access private
     */
    var $_dataModel = array();

    /**
     * HTTPץȥ롦С
     * 
     * @var    string
     * @access private
     */
    var $_protocol = 'HTTP/1.0';

    /**
     * HTTPإåη̥ơʥɡ
     * 
     * @var    integer
     * @access private
     */
    var $_statusCode = 200;

    /**
     * HTTPإåη̥ơʥƥȡ
     * 
     * @var    string
     * @access private
     */
    var $_statusText = 'OK';

    /**
     * HTTPإåη̥ơ
     * 
     * @var    array
     * @access private
     */
    var $_statusTextList = array(
            100 => 'Continue',
            101 => 'Switching Protocols',
            200 => 'OK',
            201 => 'Created',
            202 => 'Accepted',
            203 => 'Non-Authoritative Information',
            204 => 'No Content',
            205 => 'Reset Content',
            206 => 'Partial Content',
            300 => 'Multiple Choices',
            301 => 'Moved Permanently',
            302 => 'Found',
            303 => 'See Other',
            304 => 'Not Modified',
            305 => 'Use Proxy',
            306 => '(Unused)',
            307 => 'Temporary Redirect',
            400 => 'Bad Request',
            401 => 'Unauthorized',
            402 => 'Payment Required',
            403 => 'Forbidden',
            404 => 'Not Found',
            405 => 'Method Not Allowed',
            406 => 'Not Acceptable',
            407 => 'Proxy Authentication Required',
            408 => 'Request Timeout',
            409 => 'Conflict',
            410 => 'Gone',
            411 => 'Length Required',
            412 => 'Precondition Failed',
            413 => 'Request Entity Too Large',
            414 => 'Request-URI Too Long',
            415 => 'Unsupported Media Type',
            416 => 'Requested Range Not Satisfiable',
            417 => 'Expectation Failed',
            500 => 'Internal Server Error',
            501 => 'Not Implemented',
            502 => 'Bad Gateway',
            503 => 'Service Unavailable',
            504 => 'Gateway Timeout',
            505 => 'HTTP Version Not Supported',
        );

    /**
     * 󥹥ȥ饯
     * 
     * @access public
     */
    function Response()
    {
        if (isset($_SERVER['SERVER_PROTOCOL']) &&
            preg_match('/^(HTTP\/\d\.\d)$/', 
                       $_SERVER['SERVER_PROTOCOL'], $matches)) {
            $this->_protocol = $matches[1];
        }
    }

    /**
     * HTTPإåη̥ơϿ
     * 
     * @param  integer $status_code
     * @param  string  $status_text
     * @return void
     * @access public
     */
    function setStatus($status_code, $status_text = '')
    {
        if (($status_text === '') && isset($this->_statusTextList[$status_code])) {
            $status_text = $this->_statusTextList[$status_code];
        }

        $this->_statusCode = (int)$status_code;
        $this->_statusText = $status_text;
    }

    /**
     * ơֵ
     * 
     * @return string
     * @access public
     */
    function getStatus()
    {
        $status = array($this->_protocol, (string)$this->_statusCode);
        if ($this->_statusText !== '') {
            $status[] = $this->_statusText;
        }

        return 
            implode(' ', $status);
    }

    /**
     * HTTPإåˡContent-TypeפϿ
     *
     * @var    string $media
     * @var    string $charset
     * @return void
     * @access public
     */
    function setContentType($media, $charset = '')
    {
        $content_type = $media;

        if ($charset !== '') {
            $content_type .= '; charset=' . mb_preferred_mime_name($charset);
        }

        $this->setHeader('Content-Type', $content_type);
    }

    /**
     * HTTPإåˡCache-ControlפϿ
     *
     * @var    string $name
     * @var    string $value
     * @return void
     * @access public
     */
    function setCacheControl($name, $value = null)
    {
        $cache_control   = $this->getHeader('Cache-Control');
        $current_headers = array();
        if ($cache_control !== '') {
            foreach (preg_split('/\s*,\s*/', $cache_control) as $buf) {
                $buf = explode('=', $buf);
                $current_headers[$buf[0]] = isset($buf[1]) ? $buf[1] : null;
            }
        }
        $current_headers[strtr(strtolower($name), '_', '-')] = $value;

        $headers = array();
        foreach ($current_headers as $varname => $varvalue) {
            $headers[] = $varname . (isset($varvalue) ? '='.$varvalue : '');
        }

        $this->setHeader('Cache-Control', implode(', ', $headers));
    }

    /**
     * HTTPإåΥåɲ
     * ¸ͤˤ軰Ρ$replaceפǵưѲ
     * - $replace == true: ֤
     * - $replace == false: ɲ
     * 
     * @param  string  $name
     * @param  string  $value
     * @param  boolean $replace
     * @return void
     * @access public
     */
    function setHeader($name, $value, $replace = true)
    {
        $field_name = $this->_normalizeFieldName($name);

        if ($replace !== true) {
            $current = $this->getHeader($field_name);
            $value   = (($current !== '') ? $current . ', ' : '') . $value;
        }

        $this->_headerFields[$field_name] = $value;
    }

    /**
     * HTTPإåΥåֵ
     * 
     * @param  string $name
     * @return string
     * @access public
     */
    function getHeader($name)
    {
        $field_name = $this->_normalizeFieldName($name);

        $field_value = '';
        if (isset($this->_headerFields[$field_name])) {
            $field_value = $this->_headerFields[$field_name];
        }

        return $field_value;
    }

    /**
     * HTTPإåΥå
     * 
     * @param  string $name
     * @return void
     * @access public
     */
    function removeHeader($name)
    {
        $field_name = $this->_normalizeFieldName($name);

        if (isset($this->_headerFields[$field_name])) {
            unset($this->_headerFields[$field_name]);
        }
    }

    /**
     * HTTPإåΥåϿƤ뤫
     * 
     * @param  string  $name
     * @return boolean
     * @access public
     */
    function isHeaderExists($name)
    {
        $field_name = $this->_normalizeFieldName($name);

        return 
            isset($this->_headerFields[$field_name]);
    }

    /**
     * ϿƤHTTPإåΥåõ
     * 
     * @return void
     * @access public
     */
    function clearHeader()
    {
        $this->_headerFields = array();
    }

    /**
     * ƥץ졼ȤΥǡǥϿ
     * 
     * @param  string $varkey
     * @param  mixed  $varvalue
     * @return void
     * @access public
     */
    function setDataModel($varkey, $varvalue)
    {
        $this->_dataModel[$varkey] = $varvalue;
    }

    /**
     * ƥץ졼ȤΥǡǥֵ
     * 
     * @return array
     * @access public
     */
    function getDataModel()
    {
        return $this->_dataModel;
    }

    /**
     * ܥǥѡȤϿ
     * 
     * @param  string $content
     * @return void
     * @access public
     */
    function setContents($content)
    {
        $this->_contents = $content;
    }

    /**
     * HTTPإåȥܥǥѡȤ
     * 
     * @return void
     * @access public
     */
    function flush()
    {
        if (headers_sent($filename, $linenum)) {
            // إåʤΤǥ顼ơǤʤ
            trigger_error(
                'Unable to send HTTP header, ' . 
                    "sent to the browser in ${filename}/${linenum}", 
                E_USER_WARNING);
        } else {
            header($this->getStatus());
            foreach ($this->_headerFields as $varname => $varvalue) {
                header($varname . ': ' . $varvalue);
            }
        }
        $this->clearHeader();

        print $this->_contents;

        $this->_contents = '';
    }

    /**
     * HTTPإåեɤ̾Ȥ񼰤Ѵ
     * - ETagΤ褦㳰Ūʽ񼰤ˤ̤б
     *  - ١ʼˤθɬפȽ
     *
     * @param  string $name
     * @return string 
     * @access private
     */
    function _normalizeFieldName($name)
    {
        return 
            preg_replace(
                '/\-(.)/e', 
                "'-'.strtoupper('\\1')", 
                strtr(ucfirst(strtolower($name)), '_', '-'));
    }
}
