<?php

/**
 * The tiny modules for web application
 * - PHP versions 4 -
 * 
 * @category  web application framework
 * @package   tima
 * @author    IKEDA Youhey <youhey.ikeda@gmail.com>
 * @license   http://www.apache.org/licenses/LICENSE-2.0 Apache License, Version 2.0
 * @copyright 2007 IKEDA Youhey
 *     Licensed under the Apache License, Version 2.0 (the "License"); 
 *     you may not use this file except in compliance with the License. 
 *     You may obtain a copy of the License at 
 *         http://www.apache.org/licenses/LICENSE-2.0 
 *     Unless required by applicable law or agreed to in writing, software 
 *     distributed under the License is distributed on an "AS IS" BASIS, 
 *     WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 *     See the License for the specific language governing permissions and 
 *     limitations under the License.
 * @version  1.0.0
 */

define('UA_MOBILE_CARRIER_UNKNOW',   0);
define('UA_MOBILE_CARRIER_DOCOMO',   1);
define('UA_MOBILE_CARRIER_EZ_WEB',   2);
define('UA_MOBILE_CARRIER_SOFTBANK', 3);
/**
 * äΥ̤뤿Υ桼Ƚꥯ饹
 * 
 * - PEAR::Net_UserAgent_Mobile˰¸
 *  - 桼ȤȽΤ߻
 *  - Ʊ饹ѤǤʤХ顼ȯư۾ｪλ
 * - 󥿥եϥץΩ
 * - ̤Υ桼Ƚꥯ饹Х󥹥ȥ饯Τѹ
 * - SoftBankCüθڤΤ߸դ
 * 
 * @package    tima
 * @subpackage tima_UserAgent
 * @author     IKEDA Youhey <youhey.ikeda@gmail.com>
 */
class UserAgent
{

    /**
     * üǥ̾P502J-DN02etc...
     * 
     * @var    string
     * @access public
     */
    var $model = 'unknow';

    /**
     * üꥢ
     * 
     * @var    integer
     * @access private
     */
    var $_ua = UA_MOBILE_CARRIER_UNKNOW;

    /**
     * SoftBank Cüե饰
     * 
     * @var    integer
     * @access private
     * @todo   ե饰פμѤƤѿѻߤ
     */
    var $_softbankTypeC = false;

    /**
     * 󥹥ȥ饯
     * 
     * @access public
     * @todo   SoftBank::Cüνƹ
     */
    function UserAgent()
    {
        /* @use Net_UserAgent_Mobile */
        require_once 'Net' . DS . 'UserAgent' . DS . 'Mobile.php';

        $useragent = &Net_UserAgent_Mobile::factory();
        if (Net_UserAgent_Mobile::isError($useragent)) {
            header('HTTP/1.0 500 Internal Server Error');
            trigger_error($useragent->getMessage(), E_USER_ERROR);
            exit;
        }

        switch (true) {
        case $useragent->isDoCoMo() : 
            $this->_ua = UA_MOBILE_CARRIER_DOCOMO;
            break;
        case $useragent->isEZweb() : 
        case $useragent->isTUKa() : 
            $this->_ua = UA_MOBILE_CARRIER_EZ_WEB;
            break;
        case $useragent->isVodafone() : 
        case $useragent->isJPhone() : 
            $this->_ua = UA_MOBILE_CARRIER_SOFTBANK;
            if (method_exists($useragent, 'isTypeC') && $useragent->isTypeC()) {
                $this->_softbankTypeC = true;
            }
            break;
        }

        if ($this->isMobile() && method_exists($useragent, 'getModel')) {
            $model = $useragent->getModel();
            if (isset($model) && !empty($model)) $this->model = $model;
        }
    }

    /**
     * Singleton᥽å
     * 
     * @return UserAgent
     * @access public
     */
    function &getInstance()
    {
        static $_self;
        if (!isset($_self)) {
            $_self = new UserAgent;
        }

        return $_self;
    }

    /**
     * 桼ȤܤηáפΤΤǤ뤫򸡾
     *
     * @return boolean
     * @access public
     */
    function isMobile()
    {
        return 
            ($this->_ua !== UA_MOBILE_CARRIER_UNKNOW);
    }

    /**
     * 桼ȤDoCoMoפΤΤǤ뤫򸡾
     *
     * @return boolean
     * @access public
     */
    function isDoCoMo()
    {
        return 
            ($this->_ua === UA_MOBILE_CARRIER_DOCOMO);
    }

    /**
     * 桼ȤEZwebפΤΤǤ뤫򸡾
     *
     * @return boolean
     * @access public
     * @access public
     */
    function isEZweb()
    {
        return 
            ($this->_ua === UA_MOBILE_CARRIER_EZ_WEB);
    }

    /**
     * 桼ȤSoftBankפΤΤǤ뤫򸡾
     *
     * @return boolean
     * @access public
     */
    function isSoftBank()
    {
        return 
            ($this->_ua === UA_MOBILE_CARRIER_SOFTBANK);
    }

    /**
     * 桼ȤSoftBankפΡCüפǤ뤫򸡾
     *
     * @return boolean
     * @access public
     */
    function isSoftBankTypeC()
    {
        return 
            ($this->_softbankTypeC === true);
    }

    /**
     * üǥֵ̾
     *
     * @return string
     * @access public
     */
    function getModel()
    {
        return $this->model;
    }
}
